=== debian/changelog ===
darktable (2.0.5-2build1) yakkety; urgency=medium

  * No-change rebuild against latest libwebp

 -- Jeremy Bicha <jbicha@ubuntu.com>  Thu, 04 Aug 2016 23:50:54 -0400

darktable (2.0.5-2) unstable; urgency=medium

  * Cherry pick PR 1217 from upstream, fix for openjpeg2 (Closes: #826810)
  * Build depend on libopenjp2-7-dev instead of libopenjpeg-dev

 -- David Bremner <bremner@debian.org>  Thu, 14 Jul 2016 09:46:55 -0300

darktable (2.0.5-1) unstable; urgency=medium

  * new upstream bug fix release
  * New Features
    - Add geolocation to watermark variables
  * Bugfixes
    - Lua: fixed dt.collection not working
    - Fix softproofing with some internal profiles
    - Fix non-working libsecret pwstorage backend
    - Fixed a few issues within (rudimentary) lightroom import
    - Some fixes related to handling of duplicates and/or tags
   * Camera Support
    - Canon EOS 80D (no mRAW/sRAW support!)

 -- David Bremner <bremner@debian.org>  Mon, 11 Jul 2016 19:48:33 -0300
