## darktable 2.0.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -128,7 +128,7 @@
   elseif(NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/src/version_gen.h)
   # no need to create version_gen.h if it's already shipped. that is for example the case with our release tarballs
 #   else(NOT SOURCE_PACKAGE)
-    set(PROJECT_VERSION "archive-e388057a51314453ae3549e11e32fb28ff4ae0b7")
+    set(PROJECT_VERSION "archive-d2bec77e44ed83769a154180abf6b612537ff16f")
     execute_process(
       COMMAND ${CMAKE_SOURCE_DIR}/tools/create_version_h.sh ${CMAKE_CURRENT_BINARY_DIR}/src/version_gen.h ${PROJECT_VERSION}
       WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
@@ -137,10 +137,6 @@
 endif(DEFINED PROJECT_VERSION)
 
 
-#
-# Initial cmake/debian/postinst and prerm script for debian package
-#
-file(MAKE_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/packaging/debian)
 
 
 #
@@ -314,3 +310,5 @@
 if(NOT WIN32)
   IF(CMAKE_SYSTEM MATCHES "SunOS.*")
   add_definitions("-D_XOPEN_SOURCE=600")
+  elseif(CMAKE_SYSTEM_NAME MATCHES "^(DragonFly|FreeBSD|NetBSD|OpenBSD)$")
+  else(CMAKE_SYSTEM MATCHES "SunOS.*")
