=== data/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,14 @@
 # Generate and instal darktable.css
 #
 if ("${PC_GTK3_VERSION}" VERSION_GREATER "3.19.0")
+  if ("${PC_GTK3_VERSION}" VERSION_GREATER "3.21.0")
+    set(GTK_CSS_FONT "8pt Sans") # FIXME: does it really equal the old value?
+    set(GTK_CSS_FONT2_SIZE "15pt") # why is it different all of the sudden?
+  else ()
+    set(GTK_CSS_FONT "Sans 8")
+    set(GTK_CSS_FONT2_SIZE "10pt")
+  endif ()
+
   configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/darktable.css.in ${CMAKE_CURRENT_BINARY_DIR}/darktable.css )
 else ()
   if ("${PC_GTK3_VERSION}" VERSION_GREATER "3.13.6")
