=== debian/changelog ===
darktable (2.0.7-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- David Bremner <bremner@debian.org>  Thu, 01 Dec 2016 20:00:39 -0400

darktable (2.0.7-1) unstable; urgency=medium

  * New upstream camera-support / bugfix release
  * Support for Canon EOS 100D, 300D, 6D, 700D, 80D (sRaw1, sRaw2) Powershort A720 IS (dng)
  * Support for Fujifilm FinePix S100FS
  * Support for Nikon D3400 (12bit-compressed)
  * Support for Panasonic DMC FZ300, G8, G80, G85 (all 4:3)
  * Support for Pentax K-70
  * Fixed Base support for many Nikon cameras.
  * Dropped support for Nikon E8400, E8800, DX3 (12-bit), Df (12-bit)

 -- David Bremner <bremner@debian.org>  Wed, 26 Oct 2016 22:16:14 -0300

darktable (2.0.6-1) unstable; urgency=low

  * New upstream bug fix release
  * Bug fix: "Issues with the latest gtk3 update", thanks to Yuri D'Elia
    (Closes: #836739).
  * Fix internal build issue: do not assume that Perl's @INC contains '.'
  * OpenCL: properly discard CPU-based OpenCL devices. Fixes crashes on
    startup with some partial OpenCL implementations like pocl.
  * Bug fix: "darktable 2.0.5 crashes on OpenCL", thanks to Marc
    J. Driftmeyer (Closes: #831819).
  * Cherry-pick  abfa552,  5624412, 011d98d, eb7c475, 18d2b9d from
    next bugfix release. Whitelevel fixes for Nikon.
  * Other bugfixes and camera support improvements (see upstream release notes).

 -- David Bremner <bremner@debian.org>  Mon, 05 Sep 2016 14:56:10 -0300

darktable (2.0.4-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- David Bremner <bremner@debian.org>  Thu, 19 May 2016 09:07:11 -0300
